Index: doc/coreutils.texi
===================================================================
--- doc/coreutils.texi.orig	2011-11-07 13:50:08.592780291 +0100
+++ doc/coreutils.texi	2011-11-07 13:50:08.731778367 +0100
@@ -11436,10 +11436,38 @@ so forth.  See also the user-related com
 @cindex current working directory, printing
 @cindex working directory, printing
 
+@command{pwd} prints the name of the current directory.  Synopsis:
+
+@example
+pwd [@var{option}]@dots{}
+@end example
+
+The program accepts the following options.  Also see @ref{Common options}.
+
+@table @samp
+@item -L
+@itemx --logical
+@opindex -L
+@opindex --logical
+If the contents of the environment variable @env{PWD} provide an
+absolute name of the current directory with no @samp{.} or @samp{..}
+components, but possibly with symbolic links, then output those
+contents.  Otherwise, fall back to default @option{-P} handling.
+
+@item -P
+@itemx --physical
+@opindex -P
+@opindex --physical
+Print a fully resolved name for the current directory.  That is, all
+components of the printed name will be actual directory names---none
+will be symbolic links.
+@end table
+
 @cindex symbolic links and @command{pwd}
-@command{pwd} prints the fully resolved name of the current directory.
-That is, all components of the printed name will be actual directory
-names---none will be symbolic links.
+If @option{-L} and @option{-P} are both given, the last one takes
+precedence.  If neither option is given, then this implementation uses
+@option{-P} as the default unless the @env{POSIXLY_CORRECT}
+environment variable is set.
 
 @cindex conflicts with shell built-ins
 @cindex built-in shell commands, conflicts with
@@ -11447,9 +11475,6 @@ Because most shells have a built-in @com
 unadorned @command{pwd} in a script or interactively may get you
 different functionality than that described here.
 
-The only options are a lone @option{--help} or
-@option{--version}.  @xref{Common options}.
-
 @exitstatus
 
 
Index: NEWS
===================================================================
--- NEWS.orig	2008-05-31 23:19:59.000000000 +0200
+++ NEWS	2011-11-07 13:50:08.732778353 +0100
@@ -888,6 +888,12 @@ GNU coreutils NEWS
 
 * Major changes in release 5.93 (2005-11-06) [stable]
 
+** New features
+
+  pwd now accepts the options --logical (-L) and --physical (-P).  For
+  compatibility with existing scripts, -P is the default behavior
+  unless POSIXLY_CORRECT is requested.
+
 ** Bug fixes
 
   dircolors no longer segfaults upon an attempt to use the new
Index: src/pwd.c
===================================================================
--- src/pwd.c.orig	2008-05-26 08:40:33.000000000 +0200
+++ src/pwd.c	2011-11-07 13:54:11.700412175 +0100
@@ -1,5 +1,5 @@
 /* pwd - print current directory
-   Copyright (C) 1994-1997, 1999-2008 Free Software Foundation, Inc.
+   Copyright (C) 1994-1997, 1999-2008, 2009 Free Software Foundation, Inc.
 
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
@@ -22,7 +22,6 @@
 #include "system.h"
 #include "dirfd.h"
 #include "error.h"
-#include "long-options.h"
 #include "quote.h"
 #include "root-dev-ino.h"
 #include "xgetcwd.h"
@@ -42,6 +41,15 @@ struct file_name
 /* The name this program was run with. */
 char *program_name;
 
+static struct option const longopts[] =
+{
+  {"logical", no_argument, NULL, 'L'},
+  {"physical", no_argument, NULL, 'P'},
+  {GETOPT_HELP_OPTION_DECL},
+  {GETOPT_VERSION_OPTION_DECL},
+  {NULL, 0, NULL, 0}
+};
+
 void
 usage (int status)
 {
@@ -50,11 +58,15 @@ usage (int status)
 	     program_name);
   else
     {
-      printf (_("Usage: %s [OPTION]\n"), program_name);
+      printf (_("Usage: %s [OPTION]...\n"), program_name);
       fputs (_("\
 Print the full filename of the current working directory.\n\
 \n\
 "), stdout);
+      fputs (_("\
+  -L, --logical   use PWD from environment, even if it contains symlinks\n\
+  -P, --physical  avoid all symlinks\n\
+"), stdout);
       fputs (HELP_OPTION_DESCRIPTION, stdout);
       fputs (VERSION_OPTION_DESCRIPTION, stdout);
       printf (USAGE_BUILTIN_WARNING, PROGRAM_NAME);
@@ -283,10 +295,42 @@ robust_getcwd (struct file_name *file_na
     file_name_prepend (file_name, "", 0);
 }
 
+
+/* Return PWD from the environment if it is acceptable for 'pwd -L'
+   output, otherwise NULL.  */
+static char *
+logical_getcwd (void)
+{
+  struct stat st1;
+  struct stat st2;
+  char *wd = getenv ("PWD");
+  char *p;
+
+  /* Textual validation first.  */
+  if (!wd || wd[0] != '/')
+    return NULL;
+  p = wd;
+  while ((p = strstr (p, "/.")))
+    {
+      if (!p[2] || p[2] == '/'
+	  || (p[2] == '.' && (!p[3] || p[3] == '/')))
+	return NULL;
+      p++;
+    }
+
+  /* System call validation.  */
+  if (stat (wd, &st1) == 0 && stat (".", &st2) == 0 && SAME_INODE(st1, st2))
+    return wd;
+  return NULL;
+}
+
+
 int
 main (int argc, char **argv)
 {
   char *wd;
+  /* POSIX requires a default of -L, but most scripts expect -P.  */
+  bool logical = (getenv ("POSIXLY_CORRECT") != NULL);
 
   initialize_main (&argc, &argv);
   program_name = argv[0];
@@ -296,14 +340,42 @@ main (int argc, char **argv)
 
   atexit (close_stdout);
 
-  parse_long_options (argc, argv, PROGRAM_NAME, PACKAGE_NAME, VERSION,
-		      usage, AUTHORS, (char const *) NULL);
-  if (getopt_long (argc, argv, "", NULL, NULL) != -1)
-    usage (EXIT_FAILURE);
+  while (1)
+    {
+      int c = getopt_long (argc, argv, "LP", longopts, NULL);
+      if (c == -1)
+	break;
+      switch (c)
+	{
+	case 'L':
+	  logical = true;
+	  break;
+	case 'P':
+	  logical = false;
+	  break;
+
+	case_GETOPT_HELP_CHAR;
+
+	case_GETOPT_VERSION_CHAR (PROGRAM_NAME, AUTHORS);
+
+	default:
+	  usage (EXIT_FAILURE);
+	}
+    }
 
   if (optind < argc)
     error (0, 0, _("ignoring non-option arguments"));
 
+  if (logical)
+    {
+      wd = logical_getcwd ();
+      if (wd)
+	{
+	  puts (wd);
+	  exit (EXIT_SUCCESS);
+	}
+    }
+
   wd = xgetcwd ();
   if (wd != NULL)
     {
Index: tests/misc/pwd-option
===================================================================
--- /dev/null	1970-01-01 00:00:00.000000000 +0000
+++ tests/misc/pwd-option	2011-11-07 13:50:08.733778339 +0100
@@ -0,0 +1,83 @@
+#!/bin/sh
+# Ensure that pwd options work.
+
+# Copyright (C) 2009 Free Software Foundation, Inc.
+
+# This program is free software: you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation, either version 3 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program.  If not, see <http://www.gnu.org/licenses/>.
+
+if test "$VERBOSE" = yes; then
+  set -x
+  env -- pwd --version
+fi
+
+# from test-lib.sh
+skip_test_()
+{
+  echo "$0: skipping test: $@" | head -1 1>&9
+  echo "$0: skipping test: $@" 1>&2
+  exit 77
+}
+error_() { echo "$0: $@" 1>&2; exit 1; }
+framework_failure() { error_ 'failure in testing framework'; }
+if ( diff --version < /dev/null 2>&1 | grep GNU ) 2>&1 > /dev/null; then
+  compare() { diff -u "$@"; }
+elif ( cmp --version < /dev/null 2>&1 | grep GNU ) 2>&1 > /dev/null; then
+  compare() { cmp -s "$@"; }
+else
+  compare() { cmp "$@"; }
+fi
+# ---
+
+mkdir -p a/b || framework_failure
+ln -s a/b c || framework_failure
+base=$(env -- pwd)
+
+# Remove any logical paths from $PWD.
+cd "$base" || framework_failure
+test "x$PWD" = "x$base" || framework_failure
+
+# Enter a logical directory.
+cd c || framework_failure
+test "x$PWD" = "x$base/c" || skip_test_ "cd does not properly update \$PWD"
+
+fail=0
+env -- pwd -L > out || fail=1
+printf %s\\n "$base/c" > exp || fail=1
+
+env -- pwd --logical -P >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+env -- pwd --physical >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+# By default, we use -P unless POSIXLY_CORRECT.
+env -- pwd >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+env -- POSIXLY_CORRECT=1 pwd >> out || fail=1
+printf %s\\n "$base/c" >> exp || fail=1
+
+# Make sure we reject bogus values, and silently fall back to -P.
+env -- PWD="$PWD/." pwd -L >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+env -- PWD=bogus pwd -L >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+env -- PWD="$base/a/../c" pwd -L >> out || fail=1
+printf %s\\n "$base/a/b" >> exp || fail=1
+
+compare out exp || fail=1
+
+exit $fail
